
           {*********************************************}
           {*                                           *}
           {*  This simple program demonstrates how     *}
           {*  to digitize a few seconds of sound into  *}
           {*  computer memory and play it back through *}
           {*  a Speech Thing.                          *}
           {*                                           *}
           {*  (C) 1990 by Tomi Engdahl                 *}
           {*                                           *}
           {*********************************************}


Program Sound_Digitizer;  {source code for Turbo Pascal 4.0/5.0}
                          {this code works fine in 12 MHz AT}
			  {longer delays may be needed in faster machines}
Uses Crt;

Const lpt=1;              {put here the numeber of the LPT-port you use}

Var addr:word;
    a,x:integer;
    sound_data:array[0..32000] of byte;
    c:char;

Procedure mode(m:integer);
Begin
  If m=1 Then         {enable Digitizer for reading}
  Begin
    Port[addr+2]:=8;    {this activates the digitizer outputs}
    Port[addr]:=255;    {be sure to send 255 to output when you activate}
  End;                {the digitizer data outputs}
  If m=0 Then
  Begin
    Port[addr+1]:=0;   {disable digitizer outputs for writing to D/A-converter}
    Port[addr]:=0;
  End;
End;

Function conversion:byte;     {this function reads the result of the last}
Var w:integer;                {A/D-conversion and starts a new one}
Begin
  conversion:=Port[addr];       {read the data from digitizer}
  Port[addr+2]:=1+8;            {STROBE to 0}
  Port[addr+2]:=0+8;            {STROBE back to 1}
End;


Begin
  addr:=MemW[$0040:$0008+2*(lpt-1)];  {get printer port I/O address}
  Writeln('Press any key to start digitizing.');
  c:=readkey;
  Writeln('Now digitizing !');
  mode(1);                    {enable digitizer output}
  For a:=0 to 32000 Do        {digitizing sound to memory}
  Begin
    For x:=0 to 30 Do;        {delay to obtain right sample rate}
    sound_data[a]:=conversion;
  End;
  Sound(500);                 {notices that the sound been stored to memory}
  Writeln('Sound has been stored. Press any key to play it back.');
  Delay(100);
  NoSound;
  mode(0);                    {disable digitizer, enable sound output}
  c:=readkey;                 {wait for a keypress to play back}
  Writeln('Now playing back !');
  For a:=0 to 32000 Do        {Playing back the digitized sound through}
  Begin			      {Speech Thing}
    For x:=0 to 50 Do;        {delay to obtain right playback rate}
    port[addr]:=sound_data[a];{write sound data to D/A-converter}
  End;
End.